--
--
-- RealFillManureHeaps
--
-- # Author:  Heady
-- # date: 20.01.2019
-- # last update: 07.04.2019
--
-- > Not for commercial use  < --
-- > Not allowed for edit - Copyright (C) Heady - www.planet-ls.de < --
--

local modDir = g_currentModDirectory;

local modDescXML = loadXMLFile("modDesc", modDir .. "modDesc.xml");
local version = getXMLString(modDescXML, "modDesc.version");

print("Script: RealFillManureHeaps v"..tostring(version).." loaded by Heady - www.planet-ls.de");


local HusbandryModuleManureUpdateManure = HusbandryModuleManure.updateManure;
HusbandryModuleManure.updateManure = function(self, manureIncrease)

	self.manureDropLine = 0.025;
	--print("----------------------------")
	--print("manureIncrease: "..manureIncrease)
    local manureDropped = 0;
	if manureIncrease > g_densityMapHeightManager:getMinValidLiterValue(self.fillTypeIndex) then
		local i = 1;		
		local remainToDrop = manureIncrease;
		while true do
			if remainToDrop > 0 then
				local dropped = self:updateManureDropped(remainToDrop);
				remainToDrop = remainToDrop - dropped;
				--print("dropped: "..dropped)
			end;			
			--print("remainToDrop: "..remainToDrop)
			if remainToDrop <= g_densityMapHeightManager:getMinValidLiterValue(self.fillTypeIndex) then
				manureDropped = manureIncrease - remainToDrop;
				break;
			end;			
			if self.manureDropLine >= 1.1 then
				g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_INFO, g_i18n:getText("ingameNotification_manureHeapFull"));
				break;
			end;
			i = i + 1;
			self.manureDropLine = self.manureDropLine + 0.025;
		end;		
	end;
	--print("return manureDropped: "..manureDropped)
    return manureDropped;
end

HusbandryModuleManure.updateManureDropped = function(self, manureDrop)

	local xs, _, zs = getWorldTranslation(self.manureArea.start)
	local xw, _, zw = getWorldTranslation(self.manureArea.width)
	local xh, _, zh = getWorldTranslation(self.manureArea.height)
	local ux, uz = xw - xs, zw - zs
	local vx, vz = xh - xs, zh - zs
	local vLength = MathUtil.vector2Length(vx, vz)

	local sx = xs + self.manureDropLine * ux + 0 * vx        -- ( ux / uLength ) + ( vx / vLength )
	local sz = zs + self.manureDropLine * uz + 0 * vz        -- ( uz / uLength ) + ( vz / vLength )
	local sy = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, sx, 0, sz) + 10.0
	local ex = xs + (self.manureDropLine+0.1) * ux + 1 * vx        -- xw - ( ux / uLength ) + ( vx / vLength )
	local ez = zs + (self.manureDropLine+0.1) * uz + 1 * vz        -- zw - ( uz / uLength ) + ( vz / vLength )
	local ey = sy                               -- getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, ex, 0, ez) + 10
	local dropped, lineOffset = DensityMapHeightUtil.tipToGroundAroundLine(nil, manureDrop, self.fillTypeIndex, sx, sy, sz, ex, ey, ez, 0, vLength, self.lineOffsetManure, false, nil)

    return dropped;
end;



--[[HusbandryModuleManure.onIntervalUpdate = function(self, dayToInterval)
    HusbandryModuleManure:superClass().onIntervalUpdate(self, dayToInterval)
    if self.singleAnimalUsagePerDay > 0 then
        local hasStraw = self.owner:hasStraw()
        if hasStraw then
            if self.manureToDrop > g_densityMapHeightManager:getMinValidLiterValue(self.fillTypeIndex) then
                local maxManureToDrop = self.manureToDrop --math.min(self.manureToDrop, 20.0 * g_densityMapHeightManager:getMinValidLiterValue(self.fillTypeIndex))
                local dropped = self:updateManure(maxManureToDrop)
                self.manureToDrop = self.manureToDrop - dropped
            end
            local totalNumAnimals = self.owner:getNumOfAnimals()
            local newManure = totalNumAnimals * self.singleAnimalUsagePerDay * dayToInterval * 200;
            self.manureToDrop = self.manureToDrop + newManure
            local manureLevel = self:getManureLevel()
            self.fillLevel = manureLevel + self.manureToDrop
        end
    end
end]]

ModEvent = {};

function ModEvent:loadMap(name)
end;

function ModEvent:deleteMap()
end;

function ModEvent:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ModEvent:keyEvent(unicode, sym, modifier, isDown)
end;

function ModEvent:update(dt)
end;

function ModEvent:draw()
end;

--addModEventListener(ModEvent);
